package ru.landgrafhomyak.bgtu.networks0.build_script

import org.jetbrains.kotlin.gradle.dsl.KotlinMultiplatformExtension
import org.jetbrains.kotlin.gradle.plugin.KotlinTarget
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.configureAllCompilersOptions

fun KotlinTarget.suppressWarnings(vararg warningNames: String) {
	this.compilations.configureEach c@{
		this@c.compileTaskProvider.configure t@{
			this.compilerOptions a@{
				warningNames.map { w -> "-Xsuppress-warning=${w}" }.let(this@a.freeCompilerArgs::addAll)
			}
		}
	}
}

fun KotlinMultiplatformExtension.suppressWarnings(vararg warningNames: String) {
	this.targets.configureEach t@{ this@t.suppressWarnings(*warningNames) }
}


fun KotlinMultiplatformExtension.configureWarnings() {
	this.configureAllCompilersOptions a@{ this@a.freeCompilerArgs.addAll("-Wextra", "-Xexpect-actual-classes") }
	this.suppressWarnings()
}

