import ru.landgrafhomyak.bgtu.networks0.build_script.Dependencies
import ru.landgrafhomyak.bgtu.networks0.build_script.configureWarnings
import ru.landgrafhomyak.bgtu.networks0.build_script.setupHierarchy

plugins {
	kotlin("multiplatform")
}

repositories {
	mavenCentral()
}


kotlin {
	configureWarnings()

	jvm()

	mingwX64()
	linuxX64()
	linuxArm64()
	macosX64()
	macosArm64()
	sourceSets {
		setupHierarchy()

		commonMain {
			dependencies {
				implementation(Dependencies.kotlin_atomicfu)
				implementation(project(":modules:utilities"))
			}
		}

		nativeMain {
			dependencies {
				implementation(project(":modules:low-level:c-interop-utilities"))
			}
		}
	}
}