package ru.landgrafhomyak.bgtu.networks0.low_level.multithreading

import kotlin.contracts.ExperimentalContracts
import kotlin.contracts.InvocationKind
import kotlin.contracts.contract
import ru.landgrafhomyak.bgtu.networks0.utilities.safeAutoClose1

@OptIn(ExperimentalContracts::class)
inline fun <R> Mutex.withLock(synchronizedBlock: () -> R): R {
	contract {
		callsInPlace(synchronizedBlock, InvocationKind.EXACTLY_ONCE)
	}
	this.lock()
	return safeAutoClose1(finally = this::unlock, synchronizedBlock)
}