package ru.landgrafhomyak.bgtu.networks0.low_level.multithreading

import kotlinx.cinterop.CFunction
import kotlinx.cinterop.CPointer
import kotlinx.cinterop.CPointerVarOf
import kotlinx.cinterop.CValuesRef
import kotlinx.cinterop.ExperimentalForeignApi
import kotlinx.cinterop.nativeHeap
import kotlinx.cinterop.alloc
import kotlinx.cinterop.free
import kotlinx.cinterop.pointed
import kotlinx.cinterop.ptr
import kotlinx.cinterop.value
import platform.posix.pthread_tVar
import platform.posix.pthread_create
import platform.posix.pthread_join

@OptIn(ExperimentalForeignApi::class)
internal actual class _PthreadsThreadBindings private constructor(private val _ptr: CPointer<pthread_tVar>) {
	actual constructor() : this(nativeHeap.alloc<pthread_tVar>().ptr)

	actual fun create(
		attr: CValuesRef<platform.posix.pthread_attr_t>?,
		routine: CPointer<CFunction<(CPointer<*>?) -> CPointer<*>?>>?,
		arg: CValuesRef<*>?
	): Int = pthread_create(this._ptr, attr, routine, arg)

	actual fun join(
		routineReturn: CValuesRef<CPointerVarOf<CPointer<*>>>?
	): Int = pthread_join(this._ptr.pointed.value, routineReturn)

	actual fun free() {
		nativeHeap.free(this._ptr)
	}
}