import ru.landgrafhomyak.bgtu.networks0.build_script.Dependencies
import ru.landgrafhomyak.bgtu.networks0.build_script.configureWarnings
import ru.landgrafhomyak.bgtu.networks0.build_script.setupHierarchy

plugins {
	kotlin("multiplatform") version "2.1.0"
}

repositories {
	mavenCentral()
}


kotlin {
	configureWarnings()

	mingwX64()
	linuxX64()
	linuxArm64()
	macosX64()
	macosArm64()
	sourceSets {
		setupHierarchy()

		commonMain {
			dependencies {
				implementation(Dependencies.kotlin_atomicfu)
				implementation(Dependencies.kotlin_coroutines_core)
				implementation(project(":modules:low-level:multithreading"))
			}
		}

		nativeMain {
			dependencies {
				implementation(project(":modules:low-level:c-interop-utilities"))
			}
		}
	}
}