package ru.landgrafhomyak.bgtu.networks0.utilities

import kotlinx.atomicfu.AtomicLong
import kotlinx.atomicfu.AtomicRef

fun AtomicLong.compareAndExchange(expected: Long, newValue: Long): Long {
	while (true) {
		val old = this.value
		if (old != expected) return old
		if (this.compareAndSet(old, newValue)) return old
	}
}

fun <T> AtomicRef<T>.compareAndExchange(expected: T, newValue: T): T {
	while (true) {
		val old = this.value
		if (old === expected) return old
		if (this.compareAndSet(old, newValue)) return old
	}
}
