import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import kotlinx.coroutines.runBlocking
import ru.landgrafhomyak.bgtu.networks0.icmp.pingSocket_IPv4
import ru.landgrafhomyak.bgtu.networks0.low_level.multithreading.Thread
import ru.landgrafhomyak.bgtu.networks0.low_level.sockets.EpollSocketEventLoop

class EventLoopRoutine(private val loop: EpollSocketEventLoop) : Thread.Routine {
	override fun run() {
		while (true) {
			try {
				this.loop.runUntilError()
			} catch (e: Throwable) {
				e.printStackTrace()
				break // todo remove
			}
		}
	}
}

fun main() {
	try {
		val loop = EpollSocketEventLoop()

		val loopThread = Thread(EventLoopRoutine(loop))
		loopThread.start()

		val googleSock = loop.pingSocket_IPv4("8.8.8.8")

		runBlocking {
			while (true) {
				print("google: ${googleSock.ping(1000u)}ms\n")
				delay(1000)
			}
		}
	} catch (e: Throwable) {
		e.printStackTrace()
	}
}