includeBuild("./modules/build-script") {
	dependencySubstitution {
		substitute(module("buildSrc:buildSrc:buildSrc")).using(project(":"))
	}
}


pluginManagement {
	repositories {
		mavenCentral()
		maven("https://maven.landgrafhomyak.ru/")
	}
	plugins {
		kotlin("multiplatform") version "2.1.0"
		id("buildSrc")
	}
	resolutionStrategy {
		eachPlugin {
			if (requested.id.id == "buildSrc")
				useModule("buildSrc:buildSrc:buildSrc")
		}
	}
}


includeBuild("./libs/int-serializers")
include(":modules:utilities")
include(":modules:low-level:c-interop-utilities")
include(":modules:low-level:multithreading")
include(":modules:low-level:sockets")
include(":modules:icmp")
include(":programs:test")